# Описание
DITranquallity - небольшая библиотека для внедрения зависимостей в приложениях, написанных на чистом Swift. Несмотря на её размер, она решает достаточно большой спектр задач, в том числе поддерживает Storyboard.

# Особенности
* Поддержка чистых Swift типов
* Нативность
* Статическая типизация
* Внедрение зависимостей через: конструктор, свойства, метод класса
* Управление временем жизни
* Поддержка Storyboard
* Указание альтернативных типов, для одного компонента
* Множественная регистрация, регистрация по умолчанию
* Получение объекта по типы и имени 
* Инициализация с параметрами
* Несколько уровней абстракций: тип, модуль, сборка
* Поддержка циклических зависимостей
* Безопасная работа из нескольких потоков
* Поиск модулей, сборок

# Главы

## [Быстрый старт](quick_start.md)
* Знакомство с идеей "инверсии управления" и "внедрения зависимостей"
* Добавление DITranquallity в ваш проект
* Регистрация компонентов
* Разрешение зависимостей
* Что дальше?

## [Регистрация компонентов](registration.md)
* Основной способ регистрации
* Указание метода инициализации
* Указание альтернативных типов
* Разрешение зависимостей при инициализации
* Добавление зависимостей после инициализации
* Циклические ссылки
* Указание параметров при инициализации

## [Создание контейнера](build.md)
* Синтаксис
* Процесс создания
* Проверки и исключения

## [Разрешение зависимостей](resolve.md)
* По типу
* По типу и имени
* По умолчанию
* Множественная
* Передача параметров
* Автоматический вывод типов
* Для существующего объекта
* Сокращенный синтаксис
* Проверки и исключения

## [Указанием имени/множественная регистрация](multi_name_registration.md)
* Множественная регистрация
* Указание зависимости по умолчанию
* Указание имени

## [Время жизни](lifetime.md)
* Одиночки (single)
* Отложенные одиночки (lazySingle)
* Область видимости (perScope)
* Всегда новый (perDependency)
* За создание отвечает кто-то другой (perRequest)

## [Модули](module.md)
* Объявление
* Регистрация

## [Сборки](assembly.md)
* Объявление
* Регистрация
* Динамические

## [Storyboard](storyboard.md)
* Регистрация ViewController
* Сокращенный синтаксис
* Создание Storyboard


## [Поиск](scan.md)
* Поиск модулей
* Поиск сборок
* Указание Bundle
* Возможности

## [Исключения](errors.md)

## [Примеры](sample.md)
* Chaos
* Delegate and Observer
* Habr
* Big Project
